// ScriptDemo3.java

import java.util.*;

import javax.script.*;

public class ScriptDemo3
{
   public static void main (String [] args) throws ScriptException
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Obtain the engine's factory so the getMethodCallSyntax() method can
      // be invoked.

      ScriptEngineFactory factory = engine.getFactory ();

      // Execute Math.class.getCanonicalName() in JavaScript.

      String stmt = factory.getMethodCallSyntax ("Math", "getCanonicalName");
      engine.put ("Math", Math.class);
      System.out.println (stmt);
      System.out.println (engine.eval (stmt));

      // Execute (new ScriptDemo4 ()).hypot (3.0, 4.0) in JavaScript.

      stmt = factory.getMethodCallSyntax ("Math", "hypot", "3.0", "4.0");
      engine.put ("Math", new ScriptDemo4 ()
                          {
                              public double hypot (double x, double y)
                              {
                                  return Math.hypot (x, y);
                              }
                          });
      System.out.println (stmt);
      System.out.println (engine.eval (stmt));
   }
}
