// ScriptDemo4.java

import javax.script.*;

public class ScriptDemo4
{
   public static void main (String [] args) throws Exception
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Execute a script that defines a function.

      engine.eval ("function sum(x, y) { return x + y; }");

      // Because the Rhino-based JavaScript script engine's internal class
      // implements the Invocable interface, engine can be cast to an
      // Invocable.

      Invocable inv = (Invocable) engine;

      // Invoke the sum() function.

      Object sum = inv.invokeFunction ("sum", 3, 4);

      // Output the sum.

      System.out.println (sum);
   }
}
