// ScriptDemo7.java

import java.io.*;

import javax.script.*;

import javax.swing.*;
import javax.swing.event.*;

public class ScriptDemo7
{
   public static void main (String [] args) throws Exception
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Define the functions specified by caldisp.js.

      engine.eval (new FileReader ("caldisp.js"));

      // Have the script send its output to out.html.

      engine.getContext ().setWriter (new PrintWriter ("out.html"));

      // Define document within JavaScript.

      String script = "var document = new Object (); " +
                      "document.writeln = function (s) { println (s); }; " +
                      "document.write = function (s) { print (s); }";
      engine.eval (script);

      // Invoke caldisp ("lightblue", "lightgreen", "white", "yellow",
      // "#e7e7e7");.

      Invocable inv = (Invocable) engine;

      inv.invokeFunction ("caldisp", "lightblue", "lightgreen", "white",
                          "yellow", "#e7e7e7");

      // Create a GUI to show the calendar.

      JFrame frame = new JFrame ();
      frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
      String path;
      path = "file:///" + (new File ("").getAbsolutePath ()) + "/out.html";
      frame.setContentPane (new JScrollPane (new JEditorPane (path)));
      frame.setSize (200, 300);
      frame.setVisible (true);
   }
}
